unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, ColorGrd, Spin, ClipBrd, IniFiles;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Create1: TMenuItem;
    Open1: TMenuItem;
    N4: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N7: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ScrollRed: TScrollBar;
    ScrollGreen: TScrollBar;
    ScrollBlue: TScrollBar;
    LabelRed: TLabel;
    LabelGreen: TLabel;
    LabelBlue: TLabel;
    SpinRed: TSpinEdit;
    SpinGreen: TSpinEdit;
    SpinBlue: TSpinEdit;
    ColorGrid1: TColorGrid;
    ComboRed1: TComboBox;
    ComboRed2: TComboBox;
    ComboGreen1: TComboBox;
    ComboGreen2: TComboBox;
    ComboBlue1: TComboBox;
    ComboBlue2: TComboBox;
    Panel1: TPanel;
    EditColor: TEdit;
    ComboColors: TComboBox;
    LabelText: TLabel;
    LabelLink: TLabel;
    LabelALink: TLabel;
    LabelVLink: TLabel;
    Memo1: TMemo;
    LabelComment: TLabel;
    ColorDialog1: TColorDialog;
    Button1: TButton;
    ComboPreColors: TComboBox;
    Close1: TMenuItem;
    N1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N5: TMenuItem;
    CopyAll: TMenuItem;
    CopyCurrent: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    Help: TMenuItem;
    View: TMenuItem;
    Bgcolor1: TMenuItem;
    Text1: TMenuItem;
    Link1: TMenuItem;
    ALink1: TMenuItem;
    VLink1: TMenuItem;
    ComboHtmlColors: TComboBox;
    procedure FormActivate(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Create1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ScrollRedChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboColorsChange(Sender: TObject);
    procedure LabelTextClick(Sender: TObject);
    procedure LabelLinkClick(Sender: TObject);
    procedure LabelALinkClick(Sender: TObject);
    procedure LabelVLinkClick(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ComboPreColorsChange(Sender: TObject);
    procedure ComboRed1Change(Sender: TObject);
    procedure ColorGrid1Change(Sender: TObject);
    procedure SpinRedChange(Sender: TObject);
    procedure EditColorKeyPress(Sender: TObject; var Key: Char);
    procedure EditColorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditColorExit(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure CopyAllClick(Sender: TObject);
    procedure CopyCurrentClick(Sender: TObject);
    procedure ReadFromString (var s:string);
    procedure OpenDialog1TypeChange(Sender: TObject);
    procedure SaveDialog1TypeChange(Sender: TObject);
    procedure Bgcolor1Click(Sender: TObject);
    procedure HelpClick(Sender: TObject);
  private
    procedure OpenForm;
    procedure ShutForm;
    procedure WriteTxtColors;
    procedure WriteHTMLColors;
    procedure ReadColors;
    procedure ReadHTMLColors;
	procedure CheckSave;
	procedure FillForm (C:TColor);
    procedure GetOneColor(Const S:String);
    procedure DefaultColors;
  public
    CurrentFileName:String;
    inFill: boolean;
  end;

var Form1: TForm1;
var Colors: array [1..5] of TColor;   {}
  f:TextFile; { }
  Ini:TIniFile; { colors.ini}
var Saved: boolean; { }
var C:TColor;
	s:String;
    InKey: Word;

implementation
uses About;

{$R *.DFM}

procedure SetIndex (index:integer);
begin
   Form1.ComboColors.ItemIndex:=index;
   Form1.View.Items[index].Checked:=True;
end;

function Dividor (c:char):boolean;
begin
 Dividor := false;
 if (c=' ') or (c=#9) or (c=#10) or (c=#13) or
    (c='#') or (c='"') or (c='''') then Dividor := true;
end;

procedure TForm1.ReadFromString (var s:string);
var Col:String[6]; //    s
    Nam:String[7];
    i,j,p,c1,c2:integer;
begin
  repeat
   i:=Pos('=',s); //  =
   if i>0 then begin
    c1:=i+1;
    while Dividor (s[c1]) = true do Inc(c1); //  
    c2:=c1+1;
    while Dividor (s[c2]) = false do Inc(c2); //  
    Col:=Copy (s,c1,c2-c1);
    c2:=i-1;
    while (Dividor (s[c2]) = true) and (c2>0) do Dec(c2);
    c1:=c2-1;
    while (Dividor (s[c1]) = false) and (c1>0) do Dec(c1);
    Nam:=Uppercase(Copy(s,c1+1,c2-c1));
    for j:=0 to 4 do begin
     if Uppercase(ComboColors.Items[j])=Nam then begin
      SetIndex (j);
      //!!!   col
      Colors[j+1]:=StringToColor ('$00'+Col);
      FillForm (Colors[j+1]);
      break;
     end;
    end;
    Delete (s,1,i+9);
   end;
  until i=0;
end;

procedure TForm1.ReadColors; {     }
begin
 Reset (f);
 Readln (f,s);
 ReadFromString (s);
 Memo1.Lines.Clear;
 while not Eof (f) do begin {}
  Readln (f,s);
  Memo1.Lines.Add(s);
 end;
end;

procedure TForm1.ReadHTMLColors;
{  HTML-  }
begin
 ShowMessage ('   -'); 
(*
 Reset (f);
 while not Eof (f) do begin
  Readln (f,s);
 end;
*)
end;

function WriteColors (start,finish:integer):String;
 {   start  finish  }
var i:integer;
begin
 s:='';
 for i:=start to finish do begin
  s:=s+Form1.ComboColors.Items[i-1]+'="#'+ IntToHex(Colors[i],6) + '" ';
 end;
 WriteColors:=s;
end;

procedure TForm1.WriteTxtColors;
 {     }
var i:integer;
begin
 ReWrite (f);
 s:=WriteColors(1,5);
 WriteLn (f,s);
 If Memo1.Lines.Count>0 Then
  for i:=0 to Memo1.Lines.Count do Writeln (f, Memo1.Lines[i]);
end;

procedure TForm1.WriteHTMLColors;
 {  HTML-  }
var i:integer;
begin
 Writeln (f,'<HTML>' + chr (13) + chr (10) +
            '<HEAD>' + chr (13) + chr (10) +
            '<TITLE></TITLE>' + chr (13) + chr (10) +
            '</HEAD>' + chr (13) + chr (10) +
            '<BODY ' + WriteColors (1,5) +
            '>' + chr (13) + chr (10));
 if Memo1.Lines.Count>0 then begin
  Writeln (f,'<!--');
  for i:=0 to Memo1.Lines.Count do Writeln (f, Memo1.Lines[i]);
  Writeln (f,'-->');
 end;
 Writeln (f,'</BODY>' + chr (13) + chr (10) + '</HTML>' );
end;

procedure TForm1.OpenForm; {  }
begin
 Save1.Enabled:=TRUE;
 SaveAs1.Enabled:=TRUE;
 Close1.Enabled:=True;
 LabelRed.Visible:=True;
 LabelGreen.Visible:=True;
 LabelBlue.Visible:=True;
 LabelText.Visible:=True;
 LabelLink.Visible:=True;
 LabelALink.Visible:=True;
 LabelVLink.Visible:=True;
 LabelComment.Visible:=True;
 ScrollRed.Visible:=True;
 ScrollGreen.Visible:=True;
 ScrollBlue.Visible:=True;
 SpinRed.Visible:=True;
 SpinGreen.Visible:=True;
 SpinBlue.Visible:=True;
 ComboRed1.Visible:=True;
 ComboRed2.Visible:=True;
 ComboGreen1.Visible:=True;
 ComboGreen2.Visible:=True;
 ComboBlue1.Visible:=True;
 ComboBlue2.Visible:=True;
 ComboColors.Visible:=True;
 Panel1.Visible:=True;
 ColorGrid1.Visible:=True;
 EditColor.Visible:=True;
 Memo1.Visible:=True;
 Memo1.Lines.Clear;
 Button1.Visible:=True;
 ComboPreColors.Visible:=True;
 Saved:=True;
 CopyAll.Enabled:=True;
 CopyCurrent.Enabled:=True;
end;

procedure TForm1.ShutForm; {  }
begin
 Save1.Enabled:=False;
 SaveAs1.Enabled:=False;
 Close1.Enabled:=False;
 LabelRed.Visible:=False;
 LabelGreen.Visible:=False;
 LabelBlue.Visible:=False;
 LabelText.Visible:=False;
 LabelLink.Visible:=False;
 LabelALink.Visible:=False;
 LabelVLink.Visible:=False;
 LabelComment.Visible:=False;
 ScrollRed.Visible:=False;
 ScrollGreen.Visible:=False;
 ScrollBlue.Visible:=False;
 SpinRed.Visible:=False;
 SpinGreen.Visible:=False;
 SpinBlue.Visible:=False;
 ComboRed1.Visible:=False;
 ComboRed2.Visible:=False;
 ComboGreen1.Visible:=False;
 ComboGreen2.Visible:=False;
 ComboBlue1.Visible:=False;
 ComboBlue2.Visible:=False;
 ComboColors.Visible:=False;
 Panel1.Visible:=False;
 ColorGrid1.Visible:=False;
 EditColor.Visible:=False;
 Memo1.Visible:=False;
 Button1.Visible:=False;
 ComboPreColors.Visible:=False;
 CopyAll.Enabled:=False;
 CopyCurrent.Enabled:=False;
 Undo1.Enabled:=False;
 Redo1.Enabled:=False;
 CurrentFileName:=' ';
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 if Form1.OpenDialog1.Execute then begin
  assignfile(f,OpenDialog1.FileName);
  {$I-}
  reset(f);
  {I+}
  if IOResult=0 then begin
   if OpenDialog1.FilterIndex=2 Then ReadHTMLColors
   else ReadColors;
   CloseFile (f);
   CurrentFileName:=OpenDialog1.FileName;
   OpenForm;
  end;
 end;
end;

procedure TForm1.CheckSave;
{ }
var SaveQuest:String; {   }
begin
 if not Saved then begin
  SaveQuest:='   ' + chr (13) +
   chr(10) + CurrentFileName + '?';
  if Application.MessageBox (PChar(SaveQuest),'!',MB_YESNO)=IDYES then
   Save1Click(Form1);
 end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 CheckSave;
 Close;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
 {    '...'}
 if CurrentFileName=' ' then SaveAs1Click(Form1)
 else begin
  assignfile(f,CurrentFileName);
  {$I-}
  rewrite(f);
  {I+}
  if IOResult=0 then begin
   if (SaveDialog1.FilterIndex=2) then WriteHTMLColors
   else WriteTxtColors;
   CloseFile (f);
   Saved:=True;
  end;
 end;
end;

function OnChangeType (s:string; n:integer):String;
const DefaultExt: array [1..2] of string=('col','htm');
var Ext:String;
begin
 Ext:=ExtractFileExt(S);
 if (Ext='') then begin
  if n<3 then S:= S + '.'+DefaultExt[n];
 end
 else begin
  if n<3 then S:=ExtractFileName(S) + '.'+DefaultExt[n];
 end;
 OnChangeType:=S;
end;

procedure TForm1.OpenDialog1TypeChange(Sender: TObject);
begin //     
 OpenDialog1.FileName:=OnChangeType (OpenDialog1.FileName,OpenDialog1.FilterIndex);
end;

procedure TForm1.SaveDialog1TypeChange(Sender: TObject);
begin //     
 SaveDialog1.FileName:=OnChangeType (SaveDialog1.FileName,SaveDialog1.FilterIndex);
end;


procedure TForm1.SaveAs1Click(Sender: TObject);
var Ext:String;
begin
 //SaveDialog1.FilterIndex:=SaveIndex;
 SaveDialog1.FileName:=CurrentFileName;
 if SaveDialog1.Execute then begin
  CurrentFileName:=SaveDialog1.FileName;
  //SaveIndex:=SaveDialog1.FilterIndex;
  CurrentFileName:=OnChangeType (CurrentFileName,SaveDialog1.FilterIndex);
  Save1Click(Form1);
 end;
end;

procedure TForm1.Create1Click(Sender: TObject);
begin //  
 if not Saved then Save1Click(Form1);
 ShutForm;
 OpenForm;
 DefaultColors;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin //   
 CheckSave;
 Saved:=True;
 ShutForm;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 Close1Click (Form1);
end;

procedure TForm1.About1Click(Sender: TObject);
begin //   
 with TAboutBox.Create(Self) do
 try
   ShowModal;
 finally
   Free;
 end;
end;

procedure TForm1.GetOneColor(Const S:String);
begin //     
 ComboPreColors.Items.Add(S);
end;

procedure TForm1.DefaultColors;
begin //  
 Colors[1]:=$00FFFFFF; {BGCOLOR}
 Colors[2]:=$00000000; {TEXT}
 Colors[3]:=$00000080; {LINK}
 Colors[4]:=$00800000; {ALINK}
 Colors[5]:=$00ff00ff; {VLINK}
 SetIndex (0);
 FillForm (Colors[1]);
 Saved:=True;
 LabelText.Font.Color:=Colors[2];
 LabelLink.Font.Color:=Colors[3];
 LabelALink.Font.Color:=Colors[4];
 LabelVLink.Font.Color:=Colors[5];
 SetIndex (0);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
 GetColorValues (GetOneColor);
{ Ini.Create(OpenDialog1.InitialDir+'\colors.ini');
 Ini.ReadSection('BrowserColors',ComboHtmlColors.Items);
 if ComboHtmlColors.Items.Count<>0 then
  ComboHtmlColors.Visible:=True; }
 Saved:=True;
 inFill:=False;
end;

procedure TForm1.FillForm (C:TColor); //   
var s:string[8]; sr:string[3];
    i,code,r,g,b:integer;
begin
 if inFill=True Then Exit;
 inFill:=True;
 s:=IntToHex (C,6);
 sr:='$'+Copy(s,1,2); r:=StrToInt (sr);
 sr:='$'+Copy(s,3,2); g:=StrToInt (sr);
 sr:='$'+Copy(s,5,2); b:=StrToInt (sr);
 if ComboColors.ItemIndex=1 then begin
  LabelText.Font.Color:=C;    Colors[2]:=C;
 end
 else if ComboColors.ItemIndex=2 then begin
  LabelLink.Font.Color:=C;    Colors[3]:=C;
 end
 else if ComboColors.ItemIndex=3 then begin
  LabelAlink.Font.Color:=C;   Colors[4]:=C;
 end
 else if ComboColors.ItemIndex=4 then begin
  LabelVLink.Font.Color:=C;   Colors[5]:=C;
 end
 else begin
  Panel1.Color:=C;           Colors[1]:=C;
 end;
 SpinRed.Value:=r;
 SpinGreen.Value:=g;
 SpinBlue.Value:=b;
 Val('$'+s[1],i,code);
 ComboRed1.ItemIndex:=i;
 Val('$'+s[2],i,code);
 ComboRed2.ItemIndex:=i;
 Val('$'+s[3],i,code);
 ComboGreen1.ItemIndex:=i;
 Val('$'+s[4],i,code);
 ComboGreen2.ItemIndex:=i;
 Val('$'+s[5],i,code);
 ComboBlue1.ItemIndex:=i;
 Val('$'+s[6],i,code);
 ComboBlue2.ItemIndex:=i;
 ScrollRed.Position:=r;  //  OnChange!
 ScrollGreen.Position:=g;
 ScrollBlue.Position:=b;
 Editcolor.Text:='#'+S;
 Saved:=False;
 inFill:=False;
end;

procedure TForm1.ScrollRedChange(Sender: TObject);
{   R,G  B}
begin
 C:=StringToColor('$00'+IntToHex(ScrollRed.Position,2)+
  IntToHex(ScrollGreen.Position,2)+
  IntToHex(ScrollBlue.Position,2));
 FillForm (C);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin //   " "
 ColorDialog1.Color:=Colors[ComboColors.ItemIndex];
 if ColorDialog1.Execute then begin
  C:=ColorDialog1.Color;
  FillForm (C);
 end
end;

procedure TForm1.ComboColorsChange(Sender: TObject);
begin  //    (Text, Link, Alink, ...)
 C:=Colors[ComboColors.ItemIndex+1];
 FillForm(C);
 View.Items[ComboColors.ItemIndex].Checked:=True;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin //   
  SetIndex (0);
  C:=Colors[1]; FillForm(C);
end;

procedure TForm1.LabelTextClick(Sender: TObject);
begin //   ""
 SetIndex (1);
 C:=Colors[2]; FillForm(C);
end;

procedure TForm1.LabelLinkClick(Sender: TObject);
begin //   ""
 SetIndex (2);
 C:=Colors[3]; FillForm(C);
end;

procedure TForm1.LabelALinkClick(Sender: TObject);
begin //   " "
 SetIndex (3);
 C:=Colors[4]; FillForm(C);
end;

procedure TForm1.LabelVLinkClick(Sender: TObject);
begin //   " "
  SetIndex (4);
  C:=Colors[5]; FillForm(C);
end;

procedure TForm1.ComboPreColorsChange(Sender: TObject);
begin //    
 C:=StringToColor(ComboPreColors.Items[ComboPreColors.ItemIndex]);
 FillForm(C);
end;

procedure TForm1.ComboRed1Change(Sender: TObject);
begin // 16-  
 C:=StringToColor('$00'+
 IntToHex(ComboRed1.ItemIndex,1)+IntToHex(ComboRed2.ItemIndex,1)+
 IntToHex(ComboGreen1.ItemIndex,1)+ IntToHex(ComboGreen2.ItemIndex,1)+
 IntToHex(ComboBlue1.ItemIndex,1)+  IntToHex(ComboBlue2.ItemIndex,1));
 FillForm (C);
end;

procedure TForm1.ColorGrid1Change(Sender: TObject);
begin //  ColorGrid
 C:=ColorGrid1.ForegroundColor;
 FillForm(C);
end;

procedure TForm1.SpinRedChange(Sender: TObject);
begin //    
 C:=StringToColor('$00'+IntToHex(SpinRed.Value,2)+IntToHex(SpinGreen.Value,2)+IntToHex(SpinBlue.Value,2));
 FillForm (C);
end;

procedure TForm1.EditColorKeyPress(Sender: TObject; var Key: Char);
{      }
begin
 If not (Key in ['0'..'9','A'..'F', 'a'..'f', '#']) then begin
  key:=#27;
  exit;
 end;
end;

procedure TForm1.EditColorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:char;
begin //     
 If not (Key in [16, 37, 39, 36, 35, 13, 27, 46, 65..70, 97..102, 48..57])
 then begin //Shift, Left, Right, Home, End, Enter, Esc, Delete
  key:=27;
  exit;
 end;
 If Key = 46 Then begin
   EditColorKeyDown(Sender, Inkey, Shift);
  Inkey:=0;
 end
 Else If Key in [65..70, 97..102, 48..57] then begin
  If Inkey=0 Then Begin
   Inkey:=Key; i:= Chr(46);
   EditColorKeyPress(Sender, i);
  End;
 end;

end;

procedure TForm1.EditColorExit(Sender: TObject);
begin //     
 s:= Editcolor.Text;
 Delete (s,1,1);
 C:= StringToColor('$00' + s);
 FillForm(C);
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin // 
 if Clipboard.HasFormat(CF_TEXT) then begin
  s:=Clipboard.AsText;
  ReadFromString (s);
 end
 else
  MessageDlg('      ',
   mtInformation, [mbOK],0);
end;

procedure TForm1.CopyAllClick(Sender: TObject);
begin //  
  Clipboard.AsText := WriteColors(1,5);
  Paste1.Enabled:=True;
end;

procedure TForm1.CopyCurrentClick(Sender: TObject);
begin //  
 Clipboard.AsText := WriteColors(ComboColors.ItemIndex+1,ComboColors.ItemIndex+1);
 Paste1.Enabled:=True;
end;

procedure TForm1.Bgcolor1Click(Sender: TObject);
var i:integer;
begin         //  
 for i:=0 to 4 do begin
  if Sender=View.Items[i] then begin
   View.Items[i].Checked:=True;
   ComboColors.ItemIndex:=i;
   C:=Colors[i+1];
   FillForm(C);
  end;
 end;
end;

procedure TForm1.HelpClick(Sender: TObject);
begin
 ShowMessage (' HTML, -, (C) PerS, 2000');
end;

end.

